//===================================================================
// Apci8759s.pas
//-------------------------------------------------------------------
// aPCI-8759
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// Date Jan.1998
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
unit Apci8759s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci8759w;

const
	szTitle		= 'Sample';
	szApci8759 	= 'aPCI-8759';

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		Function 	Apci8759_InitAxis(wLogSlot:Word;wAxis:Word):Boolean;
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSlot:Word);

	end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:		String;
	wLogSlot:	Word;
	wAxis:		Word;
	dwDllVer:	DWord;
	dwDrvVer:	DWord;
	ri:				TAPCI8759RESOURCE;
	b:				Byte;
	dwCount:	DWord;
	dwSWVal:	DWord;
begin
	//-----------------------------------------------------------------
	// Apci8759.dll J
	//-----------------------------------------------------------------
	if Apci8759wDllOpen() = False then begin
		ErrorMessage( APCI8759_SLOT_AUTO );
		Halt;
	end;
	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	if Apci8759wGetVersion(dwDllVer,dwDrvVer) = False then begin
		ErrorMessage( APCI8759_SLOT_AUTO );
		Halt;
	end;
	strbuf:= Format(
						'GetVersion'#10+
						'Dll Version:%08xH'#10+
						'Drv Version:%08xH', [dwDllVer,dwDrvVer]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
  // foCX̎gp錾
	//-----------------------------------------------------------------
	wLogSlot:=APCI8759_SLOT_AUTO; // 󂫃foCXw
	if Apci8759wCreate( wLogSlot ) = False then begin
		ErrorMessage( APCI8759_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759 Created'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if Apci8759wGetResource( wLogSlot, @ri ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759 Resource'#10+
			'PortAdr:%04xH - %04xH',
			[ri.dwIOPortBase[1],ri.dwIOPortBase[1]+ri.dwIOPortLength[1]-1]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// armXCb`̒l\
	//-----------------------------------------------------------------
	if Apci8759wGetSwitchValue( wLogSlot, dwSWVal ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759'#10 +
			'BSN:%xH', [dwSWVal]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// 䎲PɎw
	//-----------------------------------------------------------------
	wAxis := APCI8759_AXIS_1;
	//-----------------------------------------------------------------
	// 䎲܂
	//-----------------------------------------------------------------
	if Apci8759_InitAxis( wLogSlot, wAxis ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=
			'aPCI-8759'#10+
			'䎲܂';
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// { 1000pXo͋N܂
	//-----------------------------------------------------------------
	if Apci8759wDataFullWrite(
			wLogSlot, wAxis,
			APCI8759_PLUS_PRESET_PULSE_DRIVE, 1000 ) = False then begin

		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=
			'aPCI-8759'#10+
			'{1000pXo͂Ă܂';
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// hCuXe[^X擾
	//-----------------------------------------------------------------
	if Apci8759wGetDriveStatus( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// rW[tOĂihCuȂj~
	//-----------------------------------------------------------------
	if ( b and $1 ) = $1 then begin
		if Apci8759wCommandWrite(
			wLogSlot, wAxis,  APCI8759_SLOW_DOWN_STOP ) = False then begin
			ErrorMessage( wLogSlot );
			Halt;
		end;
		strbuf:=
				'aPCI-8759'#10+
				'~܂';
		ResultMessage(strbuf);
	end;
	//-----------------------------------------------------------------
	// GhXe[^X擾
	//-----------------------------------------------------------------
	if Apci8759wGetEndStatus( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759'#10+
			'GhXe[^X %02xh',[b]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// JE^[̒l\
	//-----------------------------------------------------------------
	if Apci8759wDataFullRead(
 		wLogSlot, wAxis, APCI8759_INTERNAL_COUNTER_READ, dwCount ) = False then begin
 		ErrorMessage( wLogSlot );
 		Halt;
 	end;
	//-----------------------------------------------------------------
	// g
	//-----------------------------------------------------------------
	if ( dwCount and $08000000 ) <> 0 then dwCount:=dwCount or $F0000000;

	strbuf:=Format(
			'aPCI-8759'#10+
  		'JE^[:%d',[dwCount]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// JjJVOi\
	//-----------------------------------------------------------------
	if Apci8759wGetMechanicalSignal( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759'#10+
			'JjJVOi %02xh',[b]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// jo[TVOi\
	//-----------------------------------------------------------------
	if Apci8759wGetUniversalSignal( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759'#10+
			'jo[TVOi %02xh',[b]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Apci8759wClose( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8759 Close'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	Halt;
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Apci8759wDllClose();
end;
//===================================================================
// 䎲̏
//-------------------------------------------------------------------
//   		wLogSlot	foCXԍ
//					wAxis			䎲
//                  	APCI8759_AXIS_1 ` APCI8759_AXIS_4 w肵܂
//===================================================================
Function TMainForm.Apci8759_InitAxis(wLogSlot:Word;wAxis:Word):Boolean;
begin
	Result:=False;
	//-----------------------------------------------------------------
	// MODE1 SET
	//
	// Jn|Cgo				
  // pXo͕									QpX
	// DIR   o͒[q 								CWpX  ANeBu Hi
	// PULSE o͒[q									CCWpX ANeBu Hi
	//-----------------------------------------------------------------
	if False = Apci8759wMode1Write( wLogSlot, wAxis, $40 ) then Exit;
	//-----------------------------------------------------------------
	// MODE2 SET
	//
	// EXTERNAL COUNTER ͎dl      QMS{
	// DEND ͐MANeBux	Low
	// DERR ͐MANeBux	Low
	// -SLM ͐MANeBux	Low
	// +SLM ͐MANeBux	Low
	// -ELM ͐MANeBux	Low
	// +ELM ͐MANeBux	Low
	//-----------------------------------------------------------------
	if False = Apci8759wMode2Write( wLogSlot, wAxis, $FF ) then Exit;
	//-----------------------------------------------------------------
	// [hݒ
	//
	// INPOSITION WAIT MODE RESET
	// ALARM STOP ENABLE MODE SET
	// INTERRUPT OUT ENABLE MODE RESET
	//-----------------------------------------------------------------
	if False = Apci8759wCommandWrite( wLogSlot, wAxis, APCI8759_INPOSITION_WAIT_MODE_RESET ) then Exit;
	if False = Apci8759wCommandWrite( wLogSlot, wAxis, APCI8759_ALARM_STOP_ENABLE_MODE_SET ) then Exit;
	if False = Apci8759wCommandWrite( wLogSlot, wAxis, APCI8759_INTERRUPT_OUT_ENABLE_MODE_RESET ) then Exit;
	//-----------------------------------------------------------------
	// f[^ݒ
	//
	// RANGE DATA								50		o͎gݒP 	50050=10PPS
	// START/STOP SPEED DATA		100		Jn~g 			100~10PPS=1000PPS
	// OBJECT SPEED DATA				4000	ړIg 					4000~10PPS=40000PPS
	// RATE-1 DATA              1024  ԐݒP 		1024(2.048~10^6)=0.5mSec
	//																 						(4000-100)~0.5mSec = 1.95Sec
	// RATE-2 DATA        						ftHgl 8191(1FFFh)
	// RATE-3 DATA										ftHgl 8191(1FFFh)
	// RATE CHANGE POINT 1-2					ftHgl 8191(1FFFh)
	// RATE CHANGE POINT 2-3					ftHgl 8191(1FFFh)
	//
  // ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
	//-----------------------------------------------------------------
	if False = Apci8759wDataHalfWrite( wLogSlot, wAxis, APCI8759_RANGE_WRITE, 50 ) then Exit;
	if False = Apci8759wDataHalfWrite( wLogSlot, wAxis, APCI8759_START_STOP_SPEED_DATA_WRITE, 100 ) then Exit;
	if False = Apci8759wDataFullWrite( wLogSlot, wAxis, APCI8759_OBJECT_SPEED_DATA_WRITE, 4000 ) then Exit;
	if False = Apci8759wDataFullWrite( wLogSlot, wAxis, APCI8759_RATE1_DATA_WRITE, 1024 ) then Exit;
	//-----------------------------------------------------------------
	// AhXݒ
	//
  // INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
	//-----------------------------------------------------------------
	if False = Apci8759wDataFullWrite( wLogSlot, wAxis, APCI8759_INTERNAL_COUNTER_WRITE, 0 ) then Exit;
	if False = Apci8759wDataFullWrite( wLogSlot, wAxis, APCI8759_EXTERNAL_COUNTER_WRITE, 0 ) then Exit;
	Result:=True;
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage(wLogSlot:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Apci8759wGetLastError(wLogSlot);
	if dwRes = APCI8759_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'aPCI8759 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.


